#!/bin/bash

VHOSTS_DIR=/opt/v

CURL_BIN=`which curl`

PATH_TO_ADD_A_SITE_TO_HOSTS_SCRIPT=/root/scripts/add-a-site-to-hosts.sh

if [ "$CURL_BIN" == "" ]; then
	echo "ERROR! 'curl' was not found on the server!"
	echo "Aborting ..."
	exit 1
fi

if ! [ -d "$VHOSTS_DIR" ]; then
	echo "ERROR! '$VHOSTS_DIR' is not a valid dir."
	echo "Aborting ..."
	exit 1
fi


if ! [ -s "$PATH_TO_ADD_A_SITE_TO_HOSTS_SCRIPT" ]; then
	NO_ADD_TO_HOSTS_SCRIPT=yes
fi


COUNTER=1

IFS_BACKUP=$IFS

IFS=$'\n'

ls $VHOSTS_DIR/ssl*.conf 1>&2 2>/dev/null

if [ "$?" == 0 ]; then
	for i in $(cat $VHOSTS_DIR/ssl*.conf | grep -v \# | grep "ServerName\|ServerAlias" | awk '{print $2}'); do
		URLS_ARR[$COUNTER]=https://$i
		
		COUNTER=$(expr $COUNTER + 1)
	done
fi

for i in $(ls $VHOSTS_DIR/*.conf | grep -v redirect | xargs -I {} cat {} | grep -v \# | grep "ServerName\|ServerAlias" | awk '{print $2}'); do
	URLS_ARR[$COUNTER]=http://$i
	
	COUNTER=$(expr $COUNTER + 1)
done


if ! [ "$1" == "" ]; then
	if [ "$1" -eq "$1" ] 2>/dev/null
	then
		echo "Running the commands '$CURL_BIN -k ${URLS_ARR[$1]}' and '$CURL_BIN -I -k ${URLS_ARR[$1]}' ..."
	
		echo "$CURL_BIN -k ${URLS_ARR[$1]}" | sh
		echo "$CURL_BIN -I -k ${URLS_ARR[$1]}" | sh
	else
		echo "ERROR! Invalid input."
		echo "Aborting ..."
		exit 1	
	fi
else

	COUNTER=1

	echo -e "\nPlease pick a site to test with curl:\n"

	for i in "${URLS_ARR[@]}"; do
		echo $COUNTER\) ${URLS_ARR[$COUNTER]}

		COUNTER=$(expr $COUNTER + 1)
	done

	echo q\) quit

	echo -e "\nYour Choice: "

	read NUM

	if [ "$NUM" == "q" ]; then
		echo "Exiting on user's request. Goodbye."
	else
		if [ "$NUM" -eq "$NUM" ] 2>/dev/null
		then
			echo "Running the commands '$CURL_BIN -k ${URLS_ARR[$NUM]}' and '$CURL_BIN -I -k ${URLS_ARR[$NUM]}' ..."
	
			#echo "$CURL_BIN ${URLS_ARR[$NUM]}" | sh
			
			$CURL_BIN -I -k ${URLS_ARR[$NUM]} &>/dev/null
			
			if ! [ "$?" == "0" ]; then
				if ! [ "$NO_ADD_TO_HOSTS_SCRIPT" == "yes" ]; then
					SITE_TO_ADD=${URLS_ARR[$NUM]}							
					
					TOKENS_ARR=(${SITE_TO_ADD//\/\// })

					TOKENS_ARR=(`echo ${TOKENS_ARR[@]} | tr " " "\n"`)

					$PATH_TO_ADD_A_SITE_TO_HOSTS_SCRIPT ${TOKENS_ARR[1]}
				fi
			fi	

			echo "$CURL_BIN -k ${URLS_ARR[$NUM]}" | sh
			echo "$CURL_BIN -I -k ${URLS_ARR[$NUM]}" | sh
		else
			echo "ERROR! Invalid Input."
		fi
	fi
fi

IFS=$IFS_BACKUP
